const axios = require("axios");
const events = require("events");
const emitter = new events.EventEmitter();

let api = "";
// 页数
let page = 1;
// 博客数据
let list = [];
// 用户名
// let userName = null
// 读取到那个用户
let completedUserIndex = 0;
let total = null;

// 获取所有博客数据
function GetUserInfo(names) {
  // api = `https://blog.csdn.net/community/home-api/v1/get-business-list?page=${page}&size=100&businessType=lately&noMore=false&username=${names[completedUserIndex]}`;
  api = `https://blog.csdn.net/community/home-api/v1/get-business-list?page=${page}&size=100&businessType=blog&orderby=&noMore=false&username=Dream_Weave`;
  axios.get(api).then(
    (val) => {
      if (
        val.status == 200 &&
        val.statusText == "OK" &&
        val.data.data.list.length != 0
      ) {
        page++;

        total = total ? total : val.data.data.total;
        console.log(
          "读取文章进度：",
          Math.floor((list.length / total).toFixed(2) * 100) + "%"
        );
        let tempArr = val.data.data.list.map((item) => {
          if (item.title && item.url && item.viewCount) {
            return {
              title: item.title,
              url: item.url,
              viewCount: item.viewCount,
            };
          }
        });
        list.push(...tempArr);
        // 递归
        GetUserInfo(names);
      } else {
        console.log("else!!!!!!!");
        if (completedUserIndex < names.length - 1) {
          completedUserIndex++;
          // 重置
          page = 1;
          userName = null;
          // 递归 当前用户已完成
          GetUserInfo(names);
        } else {
          if (list.length == 0) {
            console.log(
              "该用户没有文章！".red,
              "用户名称：" + names[completedUserIndex]
            );
            // process.exit(1)
          } else {
            // 以获取全部，发送数据
            emitter.emit("loadListCompleted", list);
          }
        }
      }
    },
    (reason) => {
      console.log("Error", reason);
      reject(reason);
    }
  );
}

// 导出
module.exports = {
  GetUserInfo,
  emitter,
};
